2016-12-21  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* unposted: Config/version.mk, Etc/FAQ.yo, NEWS, README:
	release 5.3.1:

2016-12-18  Baptiste Daroussin  <bapt@FreeBSD.org>

	* 40210: Completion/Unix/Command/_sysctl: Add support modern
	FreeBSD and drop support for FreeBSD < 5

2016-12-18  Baptiste Daroussin  <bapt@gandi.net>

	* 40209: Completion/BSD/Command/_chflags: Fix typo in chflags
	completion

2016-12-16  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40149: Functions/VCS_Info/Backends/VCS_INFO_get_data_git:
	vcs_info git: Avoid a fork.

	* 40203: Test/B03print.ztst: Resolve 'printf --' question from
	grandparent commit (thanks Chet).

2016-12-15  Barton E. Schaefer  <schaefer@zsh.org>

	* 40198: Test/V10private.ztst: output of B02typeset differs when
	(( UID == 0 )) so do not attempt to redo that test in that case

2016-12-14  Barton E. Schaefer  <schaefer@zsh.org>

	* 40179: Src/builtin.c: fix handling of "printf -" and "printf --"

	* unposted: Test/B03print.ztst: regression for 40179 / 37467

2016-12-12  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* unposted: Config/version.mk: update to 5.3-dev-0 to avoid
	clash with installed 5.3.

2016-12-10  Barton E. Schaefer  <schaefer@zsh.org>

	* 40134: Src/builtin.c, Src/Zle/compmatch.c: silence spurious
	compiler warnings.

2016-12-10  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40139: Test/Y03arguments.ztst: tests: Convert comments to
	diagnostics; test backslashes. (after 40129)

	* users/22182: Completion/Zsh/Context/_brace_parameter: Propagate
	22161 docs patch to completion descriptions.

2016-12-09  Oliver Kiddle  <opk@zsh.org>

	* 40137: Doc/Zsh/compsys.yo: document _external_pwds

2016-12-09  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* unposted: Config/version.mk: 5.2-test-3.

	* users/22161: Doc/Zsh/expn.yo: the (E) parameter flag is one
	after every other use of indexing.

2016-12-09  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40117: Doc/Zsh/compsys.yo, Src/input.c: Revert a hunk of
	40035 that changed semantics incorrectly.

2016-12-09  Peter Stephenson  <p.stephenson@samsung.com>

	* unposted: Test/D07multibyte.ztst: minor typos.

	* 40138: Test/D07multibyte.ztst: Put the regex test last as it
	has an additional dependency, and note this in a failure
	message.

2016-12-09  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40126: Functions/Misc/zed: zed (fned): When editing a new
	function. escape its name.

2016-12-08  Oliver Kiddle  <opk@zsh.org>

	* 40130: NEWS: mention some changes since 5.2

	* 40129: Src/Zle/computil.c, Test/Y03arguments.ztst:
	revert 39611, add code comments and test cases for _arguments

	* c.f. 40119: Src/zsh.h: correct typo in comment

	* 40114: Completion/Zsh/Context/_brace_parameter: complete
	:/ with other parameter operators

2016-12-06  Barton E. Schaefer  <schaefer@zsh.org>

	* Zhiming Wang: 40115: Functions/Zle/bracketed-paste-magic:
	revert 38579 due to bug restoring BUFFER after history search

	* 40110: Test/B02typeset.ztst: ignore strerror text in test
	output, it differs by OS

	* 40110: Test/C02cond.ztst: discard stderr when looking for
	a path to the "mount" command, to avoid spurious test failure

2016-12-06  Mikael Magnusson  <mikachu@gmail.com>

	* 40107: Completion/Linux/Command/_fusermount,
	Completion/Unix/Command/_mount: fix quoting

2016-12-06  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* unposted: Config/version.mk: 5.2-test-2.

2016-12-05  Peter Stephenson  <p.stephenson@samsung.com>

	* 40102: Test/ztst.zsh, Test/C02cond.ztst: create test IO
	files in newly created temporary directory.

	* 40100: Test/C03traps.ztst: Check ERR_EXIT and ERR_RETURN on
	anonymous functions: should exit on function return even if
	suppressed internally.

	* 40097: Src/exec.c, Test/C03traps.ztst: Don't trigger ERR_EXIT
	or ERR_RETURN on non-zero status after current shell group, either.

	* 40096: Src/exec.c, Src/loop.c, Src/zsh.h, Test/C03traps.ztst:
	Don't trigger ERR_EXIT or ERR_RETURN on non-zero status after
	shell construct.

2016-12-04  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* unposted: Functions/VCS_Info/Backends/VCS_INFO_get_data_git:
	vcs_info git: Handle rebase-apply sequences with >=10000 patches.

	* 40074: Functions/VCS_Info/Backends/VCS_INFO_get_data_git:
	vcs_info git: rfc822-unfold rebase-apply patch subjects when
	msg-clean is unavailable.

2016-12-04  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* 40088: Test/D04parameter.ztst: attempt to make output from
	interactive test more robust.

2016-12-03  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Test/D04parameter.ztst: regression test for 40071

	* 40071: Src/subst.c: change Dash back to "-" before evaluating
	named directory expansions

2016-12-03  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40068: Src/params.c, Test/B02typeset.ztst: Abort execution
	when setuid/setgid fail.

	* 40067: Src/Zle/comp.h, Src/Zle/complete.c, Src/params.c:
	internal: Document 'cmatcher', parse_cmatcher(), 'comptoend',
	unsetparam_pm(), and getindex().

2016-12-03  Daniel Hahler  <zsh@thequod.de>

	*  40029: Functions/VCS_Info/Backends/VCS_INFO_get_data_git:
	Get subject of current patch in rebase-apply mode

2016-12-02  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* unposted: Config/version.mk: 5.2-test-1.

	* 40066: Etc/FAQ.yo, README: updates for 5.3 release.

2016-12-01  Oliver Kiddle  <opk@zsh.org>

	* 40055: Completion/Unix/Command/_git: update for git 2.11.0

	* 40053: Completion/Base/Completer/_external_pwds: exclude
	current directory of active zsh from completion matches

2016-12-01  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* unposted: Functions/VCS_Info/VCS_INFO_patch2subject,
	Functions/VCS_Info/VCS_INFO_quilt, Functions/VCS_Info/vcs_info:
	vcs_info: Break out VCS_INFO_quilt-patch2subject into
	VCS_INFO_patch2subject

2016-12-01  Mikael Magnusson  <mikachu@gmail.com>

	* 40024: Completion/Unix/Type/_path_files: Update _path_files
	since quoting requirements changed in 39412, this case only
	triggers when accept-exact-dirs is set.

2016-12-01  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 40050: Src/compat.c: prepend /**/ to global functions and #ifdefs

2016-11-30  Peter Stephenson  <p.stephenson@samsung.com>

	* 40049: NEWS: notes on Unicode 9 (40037).

	* 40043: Src/Zle/computil.c: fix indentation (recent gcc warns
	about this).

2016-11-30  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40036: Completion/Debian/Command/_bts: Complete removal
	syntaxes correctly.

2016-11-29  Barton E. Schaefer  <schaefer@zsh.org>

	* 40034: Src/subst.c: clear badcshglob when ignoring errors

	* unposted: README: example describing 40032

	* 40032: Src/params.c: consistency in handling of subscript
	slices outside the bounds of an array parameter

2016-11-29  Peter Stephenson  <p.stephenson@samsung.com>

	* 40037: Joshua Rubin: Unicode 9 character width support.
	Needs enabling with --enable-unicode9.

	* 40035: Eitan Adler: Cosmetic fixes mostly for duplication in
	comments and documentation.

	* 40026: Src/Zle/zle_tricky.c: More care with redirection
	completion.  Fixes for completion after > in "!> ." that
	should add to sanity.

2016-11-29  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* unposted: Completion/Zsh/Context/_subscript: Complete the
	$foo[(f)] flag.

	* unposted: Completion/Unix/Command/_git: _git-config: Fix
	user.email completion to complete only bare email addresses.

2016-11-28  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 40011: Completion/Base/Core/_main_complete,
	Completion/Solaris/Command/_pfexec,
	Completion/Solaris/Command/_zlogin,
	Completion/Unix/Command/_chown, Completion/Unix/Command/_doas,
	Completion/Unix/Command/_sudo: Make $_comp_priv_prefix only
	declared when required, and use that to have chgrp offer all
	groups under doas, ssh, etc as well.

	* 40010: Src/builtin.c, Test/A02alias.ztst: builtins: Say
	'bad option: +x', not 'bad option: -x', when +x was passed.

	* 40009: Src/hashtable.c: alias -L: Emit aliases that begin
	with a plus sign correctly.

2016-11-24  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 40013: Completion/Unix/Type/_date_formats,
	Completion/Zsh/Command/_strftime: process zsh-specific time
	format extensions correctly

2016-11-25  Oliver Kiddle  <opk@zsh.org>

	* unposted: Functions/Zle/surround: set new vichange flag

	* 40020: Completion/Unix/Command/_cscope: new completion

2016-11-25  Laurent Arnoud  <laurent@spkdev.net>

	* 40018 + 40019: Completion/Debian/Command/_apt: Add missing
	commands to Debian apt completion

2016-11-24  Oliver Kiddle  <opk@zsh.org>

	* unposted: Completion/Unix/Command/_date: fix typo (=+ to +=)

	* 40004 (tweaked): Completion/Redhat/Command/_yum: fix cache
	mechanism, complete groups and other minor improvements

	* unposted: Src/Zle/zle_params.c: fix to compile on Solaris where
	curses.h has a #define for reg to register

	* 40003: Src/Zle/zle_params.c, Doc/Zsh/zle.yo: include "0-"9
	vi buffers in the registers associative array

2016-11-24  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 40005: Completion/Unix/Command/_date,
	Completion/Unix/Type/_date_formats: call _date_formats from _date.
	Update both files for darwin etc.

2016-11-24  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39982: README, Src/utils.c: $SPROMPT: Don't accept a spelling
	correction at space/tab.

2016-11-23  Bart Schaefer  <schaefer@zsh.org>

	* unposted: Src/Zle/zle_main.c: clear ERRFLAG_ERROR before
	invoking immortal widget (cf. 39934)

2016-11-23  Oliver Kiddle  <opk@zsh.org>

	* unposted: Test/Y03arguments.ztst: partial match test case

	* unposted: Src/builtin.c, Test/B03print.ztst: fix printf -v
	to an array without format string reuse

2016-11-21  Oliver Kiddle  <opk@zsh.org>

	* 39993: Test/Y01completion.ztst: Tests for 39981.

2016-11-21  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39981: Src/Zle/compresult.c: Make compstate[to_end] skip
	suffix and hidden suffix, but not ignored suffix.

2016-11-20  Oliver Kiddle  <opk@zsh.org>

	* 39986, 39989: Src/Zle/zle.h, Src/Zle/zle_keymap.c,
	Src/Zle/zle_main.c, Src/Zle/zle_misc.c, Src/Zle/zle_thingy.c,
	Src/Zle/zle_utils.c, Src/Zle/zle_vi.c, Test/X02zlevi.ztst,
	Doc/Zsh/zle.yo, Functions/Zle/vi-pipe: make vi-repeat-change
	work better with shell based widgets and save old change
	when recording a new change in case the new one fails

	* 39974: Completion/Unix/Command/_ssh: complete shared
	libraries for -e and -s options to ssh-add

2016-11-20  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* Guillaume Maudoux: 39900 (doc slightly tweaked): Src/params.c,
	Doc/Zsh/params.yo: Add TERMINFO_DIRS special colon-separated
	array, not tied.

	* 39995 (from 39977): Src/params.c, Test/A06assign.ztst:
	optimisation of string assignment if length is unchanged.

	* Mikel Ward: 39978: Doc/Zsh/jobs.yo: more accurate
	documentation of searching for job by string.

2016-11-20  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* Sebastian: 39992: Src/params.c: setarrvalue: Allocate
	a correctly-sized array.

	* unposted (after 39952): Src/Zle/zle_params.c: Restore C89
	compatibility.

	* 39985: Doc/Zsh/params.yo: Document the [nyae] answers to the
	spelling correction prompt, $SPROMPT.

2016-11-18  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39916 + 39930 + tweak: Completion/Unix/Command/_git: Complete
	options and values for -c.

2016-11-17  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* 39958: Src/Zle/compctl.c, Src/builtin.c, Src/compat.c,
	Src/exec.c, Src/glob.c, Src/hist.c, Src/utils.c: Add spare byte
	to PATH_MAX allocation to allow for possible null.

2016-11-17  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39921: Completion/Unix/Command/_git: __git_recent_branches:
	Remove erroneous parsing of partial ref names as tags.

	* 39922: Completion/Unix/Command/_git: __git_recent_branches:
	Fix an 'assertion' failure when two branches (refs) point to
	the same commit.

	* 39917: Completion/Zsh/Command/_precommand: Complete setsid(1)
	as a precommand

	* 39915: Src/exec.c, Test/E01options.ztst: whence: Honor
	PATH_DIRS option for arguments that start with './' or '../'.

2016-11-17  Oliver Kiddle  <opk@zsh.org>

	* 39962: Src/Zle/zle_keymap.c: bind vi case conversion widgets
	u/U in visual mode and g~ from normal mode

	* 39959: Src/Zle/zle_vi.c, Test/X02zlevi.ztst: when repeating
	vi changes advance through the numbered killring registers.
	Also fix numeric arguments with vi-repeat-change.

	* 39952: Src/Zle/zle_params.c, Doc/Zsh/zle.yo: add registers
	special parameter to provide access to the vi register
	buffers from a zle widget function

2016-11-16  Oliver Kiddle  <opk@zsh.org>

	* 39945: Src/Zle/compcore.c, Completion/Base/Core/_message,
	Test/Y03arguments.ztst: allow further tab presses to move on
	to menu completion even when compstate[insert] is emptied

2016-11-15  Peter Stephenson  <p.stephenson@samsung.com>

	* 39949: Src/subst.c, Src/utils.c, Test/B09hash.ztst: "-" is
	allowed in named directories, so needs a special case when
	sh-tokenized for possible ranges.

	* 39947: Test/D04parameter.ztst: Test out-of-rantge multiple
	array subscripts with and without (@).

2016-11-14  Barton E. Schaefer  <schaefer@zsh.org>

	* 39943: Src/utils.c: no need to compute arrlen() in arrdup_max()
	when max == 0.

2016-11-15  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 39937: Src/params.c: fix a problem introduced by 39886.
	$a[i,j] should become an empty array if i>j.

2016-11-14  Peter Stephenson  <p.stephenson@samsung.com>

	* 39906: Src/utils.c: More optimisation of multibyte handling
	for US-ASCII along existing lines.

2016-11-13  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Src/Zle/zle_utils.c: comment in zlecallhook() points
	to redrawhook() just in case

	* 39934: Src/Zle/zle_main.c: if a widget execution fails, try to
	execute a corresponding immortal widget instead.

	* 39933: Src/Zle/zle_main.c: more of zlecallhook() in redrawhook(),
	add commentary on some of the differences

	* 39929: Doc/Zsh/zle.yo: clarify execute{,-last}-named-cmd

2016-11-12  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Etc/zsh-development-guide: add list of standard
	module hooks with corresponding macro names

2016-11-12  Oliver Kiddle  <opk@zsh.org>

	* Paul Seyfert: 39920: Completion/Redhat/Command/_yum:
	extend yum completion to cover more yum commands

2016-11-10  Barton E. Schaefer  <schaefer@zsh.org>

	* 39893: Src/params.c: use arrdup_max() to show explicitly the
	difference in two code branches; no functional change

2016-11-11  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39874/0002 plus size=0 handling: Src/mem.c: zshcalloc: Remove
	code duplication. No functional change.

	* 39874/0001: Src/params.c: setarrvalue: Remove needless
	initialization.

2016-11-10  Peter Stephenson  <p.stephenson@samsung.com>

	* 39901: Src/exec.c, Test/C03traps.ztst: Exiting the left hand
	side of a pipeline shouldn't trigger EXIT trap.

2016-11-09  Oliver Kiddle  <opk@zsh.org>

	* 39890: Completion/Debian/Command/_git-buildpackage,
	Completion/Debian/Command/_lintian,
	Completion/Debian/Command/_make-kpkg,
	Completion/Linux/Command/_iwconfig,
	Completion/Debian/Command/_dcut, Completion/Linux/Command/_mdadm,
	Completion/Solaris/Command/_dladm, Completion/Unix/Command/_adb,
	Completion/Unix/Command/_attr, Completion/Unix/Command/_awk,
	Completion/Unix/Command/_bzr, Completion/Unix/Command/_cdrdao,
	Completion/Unix/Command/_devtodo, Completion/Unix/Command/_feh,
	Completion/Unix/Command/_global, Completion/Unix/Command/_groff,
	Completion/Unix/Command/_growisofs,
	Completion/Unix/Command/_initctl, Completion/Unix/Command/_iostat,
	Completion/Unix/Command/_ip, Completion/Unix/Command/_java,
	Completion/Unix/Command/_localedef, Completion/Unix/Command/_make,
	Completion/Unix/Command/_mencal, Completion/Unix/Command/_module,
	Completion/Unix/Command/_nkf, Completion/Unix/Command/_nmap,
	Completion/Unix/Command/_pbm, Completion/Unix/Command/_rar,
	Completion/Unix/Command/_sisu, Completion/Unix/Command/_sqsh,
	Completion/Unix/Command/_surfraw, Completion/Unix/Command/_units,
	Completion/Unix/Command/_wiggle: fix typos and spellings

	* 39888: Completion/Unix/Command/_tmux: update for tmux 2.3

	* 39884: Functions/Zle/history-beginning-search-menu:
	fix for history lines containing a pipe character

2016-11-09  Barton E. Schaefer  <schaefer@zsh.org>

	* 39882: Doc/Zsh/expn.yo: mention ${name:/pattern/replacement}
	in the itemized synopsis with the related forms; clarify doc.

2016-11-09  Peter Stephenson  <p.stephenson@samsung.com>

	* 39887: Src/params.c: no need to conditionalise assignment of
	strlen in getstrvalue().

	* 39886 based on 39877 (Sebastian): Src/params.c, Src/utils.c:
	add arrdup_max() so as not to duplicate entire arrays unnecessarily.

	* Sebastian: 39875: Src/params.c, Src/string.c: add
	dupstring_glen() to avoid redundant strlen() calls.

2016-11-09  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39853: Completion/Unix/Command/_subversion: Accept long
	options in the '--foo=bar' syntax.

2016-11-08  Peter Stephenson  <p.stephenson@samsung.com>

	* Sebastian: 39871: cut down number of strlen()s in getstrvalue().

2016-11-08  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 39857: Completion/Unix/Command/_top: add support for darwin,
	with improvements on linux etc.

2016-11-08  Peter Stephenson  <p.stephenson@samsung.com>

	* 39870: Src/builtin.c, Test/C03traps.ztst: ensure exit trap can
	always run.

	* unposted: Src/utils.c: follow up to 39867: don't need test
	against zero any more.

	* Sebastian: 39869: can transfer ownership of core of array when
	assigning.

	* 39867: Src/utils.c: cast to unsigned char to compare against
	0x7f.

2016-11-07  Peter Stephenson  <p.stephenson@samsung.com>

	*  Felix Neumärker: Completion/Unix/Command/_module: follow
	symbolic links and use _multi_parts for paths.

	* zsh-users/22083: Doc/Zsh/expn.yo: attempt to explain a bit
	better what a "word" is in parameter substitution.

2016-11-07  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39840: Completion/Unix/Command/_cpio: Declare variable's
	type correctly.

2016-11-07  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 39728: Src/zsh_system.h, Src/Modules/datetime.c: define
	_GNU_SOURCE on Cygwin

	* 39855: Completion/BSD/Command/_jot: new completion

2016-11-07  Frank Terbeck  <ft@bewatermyfriend.org>

	* 39849: Completion/Unix/Command/_tmux: _tmux: Remove
	set-remain-on-exit

2016-11-06  Frank Terbeck  <ft@bewatermyfriend.org>

	* 39847: Util/check-tmux-state: Update helper function name
	pattern

	* 39848: Completion/Unix/Command/_tmux: _tmux: Update options to
	latest tmux

2016-11-05  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Completion/compaudit: tweak replacement getent
	to handle /etc/hosts format.

	* Thomas Bereknyei, Mic92: 39831: Completion/compaudit: find
	"getent" by the usual command search, not just /usr/bin/.

	* unposted: Test/A05execution.ztst:  tests for 39839, 39844

	* 39844: Src/loop.c: fix "while" condition as per 39839

	* 39839: Src/loop.c: fix "return" from "if" condition

	* 39838: Src/builtin.c: another missing unqueue_signals()

2016-11-04  Oliver Kiddle  <opk@zsh.org>

	* 39829: Src/Zle/compcore.c: when compstate[insert] is emptied
	by the completion function and AUTO_MENU is set, start menu
	completion on the second tab press rather than the third

	* 39834: Src/builtin.c, Completion/Zsh/Command/_print,
	Completion/Zsh/Command/_fc, Completion/Zsh/Type/_ps1234:
	when print used with -v and -l, include a final
	newline; complete print -S option and make further use
	of the new printf to an array feature

	* 39389: Src/builtin.c, Test/B03print.ztst, Doc/Zsh/builtins.yo,
	Completion/Zsh/Type/_globquals, Completion/Zsh/Command/_print:
	when printf -v is used with an array use separate elements each
	time the format is reused

2016-11-04  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* users/22080: Doc/Zsh/zle.yo: bracketed-paste: Third time's
	a charm.

2016-11-04  Peter Stephenson  <p.stephenson@samsung.com>

	* Sebastian: 39825: Src/utils.c: Optimise mb_metastrlenend() for
	the common case of 7-bit character.

2016-11-04  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 39818 (Oliver Kiddle): Completion/Unix/Command/_awk: add nawk

2016-11-03  Barton E. Schaefer  <schaefer@zsh.org>

	* 39824: Test/X02zlevi.ztst: test case for 39811

2016-11-03  Peter Stephenson  <p.stephenson@samsung.com>

	* unposted: Src/Zle/zle_keymap.c: comment explaining putting
	back tail end of key buffer into input.

2016-11-03  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39806: Src/Zle/zle_vi.c: internal: Document zle's vichgbuf.

	* 39805: Src/Zle/comp.h, Src/Zle/compcore.c: internal: Document
	some compadd internals.

	* 39804: Src/Zle/comp.h, Src/Zle/complete.c: internal: Document
	matchspec flags.

	* 39803: Src/Zle/complete.c: internal: Document bin_compadd().

	* 39802: Src/Zle/compcore.c, Src/Zle/complete.c: internal:
	Document and simplify multiquote().

	* users/22063: Doc/Zsh/zle.yo: bracketed-paste: Document ability
	to specify a vi register. (after users/22036)

2016-11-03  Daniel Hahler  <zsh@thequod.de>

	* 39822: Completion/Unix/Command/_git: remove "-A '-*'" with
	_arguments for some commands.

2016-11-03  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Completion/Unix/Type/_remote_files: fix typo that
	was causing handling of "--" argument to fail

	* 39820: Src/Zle/zle_vi.c: vi-repeat handles multi-key bindings

2016-11-03  Peter Stephenson  <p.stephenson@samsung.com>

	* 39815: Src/lex.c, Test/D04parameter.ztst: read input to end
	on parse error in $(...) inside a string.

2016-11-02  Barton E. Schaefer  <schaefer@zsh.org>

	* 39813: Src/Zle/zle_keymap.c: fix keybuflen after ungetting
	extra keys from the end of keybuf in getkeymapcmd().

	* 39811: Src/Zle/zle_vi.c: vi-repeat-change must not be the
	"motion" of vi-change, lest it infinitely repeat itself.

2016-11-01  Jun-ichi Takimoto <takimoto-j@kba.biglobe.ne.jp>

	* 39731: Completion/Unix/Command/_awk: add support for gawk
	ver.3 and 4

2016-11-01  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39787: Test/Y01completion.ztst: Add a regression test for
	39412.

2016-10-31  Barton E. Schaefer  <schaefer@zsh.org>

	* 39797: Completion/Unix/Type/_canonical_paths: obsolete the
	helper functions fixed by the previous two changes, replacing
	them with the new ${var:P} modifier.

	* 39795: Completion/Unix/Type/_canonical_paths: preserve "cd -"
	behavior around directory shuffling in _canonical_paths_pwd

	* 39792: Completion/Unix/Type/_canonical_paths: improve handling
	of relative paths in _canonical_paths_add_paths

2016-10-31  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39786: Functions/VCS_Info/Backends/VCS_INFO_get_data_hg,
	Functions/VCS_Info/VCS_INFO_hexdump, Functions/VCS_Info/vcs_info:
	vcs_info (hg): Use native hexdump implementation instead of
	external command.

2016-10-30  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* 39777: Src/parse.c, Test/D08cmdsubst.ztst: $() is a valid
	empty command substitution.

2016-10-29  Barton E. Schaefer  <schaefer@zsh.org>

	* 39758: Src/builtin.c, Src/params.c: revise 39704 to output
	"typeset" for array and hash parameters, even when exported; for
	POSIXBUILTINS, "export var" does not implicitly set $var, and its
	export state is preserved when assigned (but not when explicitly
	unset).

2016-10-28  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* users/22036: Doc/Zsh/zle.yo: bracketed-paste: Document
	cutbuffer behaviour; clarify.

2016-10-27  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Functions/Zle/bracketed-paste-magic: handle empty
	pastes and "zle bracketed-paste variablename" form.

2016-10-27  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* unposted: Doc/Zsh/compsys.yo, Doc/Zsh/contrib.yo: Minor
	documentation fixes (markup, grammar, etc).

	* 39739: Completion/Unix/Command/_head,
	Completion/Unix/Command/_tail: Complete negative integers for
	-n/-c in the GNU variant.  (after 39479)

2016-10-25  Barton E. Schaefer  <schaefer@zsh.org>

	* 39725: Src/Zle/complist.c: more metafication of patterns.

2016-10-25  Peter Stephenson  <p.stephenson@samsung.com>

	* 39723: Src/Zle/complist.c, Src/glob.c: metafy string to be
	used in pattern for complist.  Also skip metafied characters
	when tokenizing (typically this has no effect, however).

2016-10-24  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: NEWS, README: update for 39704.
	
	* 39704: Src/params.c, Test/B02typeset.ztst, Test/B03print.ztst,
	Test/V10private.ztst: the output of "typeset -p" uses "export"
	commands or the "-g" option for parameters that are not local to
	the current scope.

2016-10-24  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39706: Completion/Unix/Type/_tilde_files, Doc/Zsh/compsys.yo:
	_tilde_files: Offer named directories. Document.

	* 39708: Completion/Unix/Type/_email_addresses,
	Doc/Zsh/compsys.yo: Document _email_addresses.

	* 39707: Doc/Zsh/compsys.yo: Document _dir_list.

2016-10-23  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* 39715: Src/Zle/complist.c: handle multibyte characters when
	highlighting completion listing.

2016-10-22  Barton E. Schaefer  <schaefer@zsh.org>

	* 39710 (cf. Alex George: 39709): Completion/Base/Completer/_expand,
	Completion/Base/Completer/_user_expand: handle the %o format in the
	"all-expansions" tag; allow a single unique match to appear in the
	"expansions" tag (cf. users/21955).

2016-10-20  Peter Stephenson  <p.stephenson@samsung.com>

	* 39688: Src/pattern.c: Alternative fix: next pointer is
	irrelevant anyway as there's only one P_EXACTLY in a P_PURES.

	* 39683: Src/pattern.c: Update scan pointer in pattern after
	possible reallocation for meta handling.

2016-10-19  Barton E. Schaefer  <schaefer@zsh.org>

	* 39680: Src/mem.c: correctly handle case of popping last arena

2016-10-19  Peter Stephenson  <p.stephenson@samsung.com>

	* 39678: Src/builtin.c, Test/D07multibyte.ztst: printf %q
	argument needs metafying and result unmetafying.

2016-10-18  m0viefreak  <m0viefreak.cm@googlemail.com>

	* 39590: Src/Zle/compresult.c: zle: Call zle-line-pre-redraw
	after inserting a completion result

2016-10-18  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39654: Completion/Unix/Command/_make: (based on patch by
	Baptiste Daroussin) Better support bmake, FreeBSD's default
	make(1) implementation.

	* 39657: Completion/Zsh/Command/_zstyle: Complete the -g,
	-s,-b,-a, -t,-T, -m options.

	* 39657: Completion/Zsh/Command/_zstyle: When completing a
	style for an unrecognised context, complete all known styles.

	* 39657: Completion/Zsh/Command/_zstyle,
	Completion/Zsh/Type/_completers, Doc/Zsh/compsys.yo: Make a
	helper function global.

2016-10-16  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39500: Src/Zle/computil.c: compdescribe: perform
	on-screen-width computation using the "nice" length, since the
	matches are rendered by nice*() functions by compadd

2016-10-13  Oliver Kiddle  <opk@zsh.org>

	* 39624: Completion/Unix/Command/_yafc: remove space before
	compdef that prevents function being used plus other tweaks

	* 39623: Completion/X/Command/_evince: new completion

2016-10-13  Peter Stephenson  <p.stephenson@samsung.com>

	* 39625: Martijn Dekker: Src/loop.c, Test/A01grammar.ztst: case
	needs to reset lastval if no pattern matched.

2016-10-13  Oliver Kiddle  <opk@zsh.org>

	* 39622: Test/Y03arguments.ztst: add test cases for recent
	_arguments fixes, exclusion lists and -A/-S

	* 39611: Src/Zle/computil.c: with _arguments sets completion
	stopped if one of the rest arguments starts with a dash

	* 39533: Matthew Martin: Completion/Unix/Command/_doas:
	add the new -L option, sort options and add some exclusions

2016-10-11  Peter Stephenson  <p.stephenson@samsung.com>

	* 36108: Src/builtin.c: command -[vV] assumed -p.

2016-10-10  Peter Stephenson  <p.stephenson@samsung.com>

	* 39599: Src/loop.c, Test/A01grammar.ztst: Don't reset status
	before "case" execution.

2016-10-07  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39522: Doc/Zsh/contrib.yo: add-zsh-hook/add-zle-hook-widget:
	Promise append semantics.

	* 39489: Completion/Unix/Type/_path_files: Interpret -P as
	literally, rather than as a pattern.

	* 39479 + 39481 minus _path_files hunk (see
	39489): Completion/Debian/Command/_debfoster,
	Completion/Linux/Command/_modutils,
	Completion/Redhat/Command/_rpm, Completion/Unix/Command/_ant,
	Completion/Unix/Command/_cpio, Completion/Unix/Command/_cvs,
	Completion/Unix/Command/_dbus, Completion/Unix/Command/_git,
	Completion/Unix/Command/_graphicsmagick,
	Completion/Unix/Command/_growisofs, Completion/Unix/Command/_gs,
	Completion/Unix/Command/_gsettings,
	Completion/Unix/Command/_head,
	Completion/Unix/Command/_imagemagick,
	Completion/Unix/Command/_java, Completion/Unix/Command/_lp,
	Completion/Unix/Command/_lzop, Completion/Unix/Command/_mount,
	Completion/Unix/Command/_perl, Completion/Unix/Command/_php,
	Completion/Unix/Command/_rlogin, Completion/Unix/Command/_ssh,
	Completion/Unix/Command/_tail, Completion/Unix/Command/_w3m,
	Completion/X/Command/_rdesktop, Completion/X/Command/_x_utils,
	Completion/Zsh/Command/_fc, Completion/Zsh/Type/_arrays,
	Completion/Zsh/Type/_globflags, Completion/Zsh/Type/_ps1234,
	Completion/Zsh/Type/_vars: Completion: audit 'compset -P'
	calls to use shortest match where applicable, plus random
	drive-by tweaks.

2016-10-06  Peter Stephenson  <p.stephenson@samsung.com>

	* Julien Cretin: 39579: Src/subst.c: position of \0
	with optional quoting in parameter substitution was wrongly
	calculated.

	* 39578: Test/C03traps.ztst: Test some more ERR_RETURN cases
	involving "&&" and functions.

2016-10-05  Peter Stephenson  <p.stephenson@samsung.com>

	* 39571: Src/exec.c, Test/C03traps.ztst: "&&" inside a shell
	function could mess up ERR_EXIT outside.

	* 39568: Src/exec.c, Test/C03traps.ztst: "! <complex-command>"
	should suppress ERR_EXIT inside the complex command.

	* 39566: README, Doc/Zsh/exec.yo, Src/exec.c,
	Test/C04funcdef.ztst: change the behaviour of
	command_not_found_handler to make it easier to handle a non-zero
	return status naturally.

2016-10-04  Barton E. Schaefer  <schaefer@zsh.org>

	* 39561: Src/mem.c: missing unqueue_signals() when ZSH_HEAP_DEBUG

2016-10-03  Barton E. Schaefer  <schaefer@zsh.org>

	* 39550: Src/Zle/zle_main.c: reset signal queue in recursiveedit()

	* 39548: Src/signals.c, Src/signals.h: DEBUG for queueing_enabled

	* 39547: Src/Zle/zle_main.c: handle zero delta in calc_timeout()

2016-10-03  Peter Stephenson  <p.stephenson@samsung.com>

	* 39545: Src/builtin.c, Src/exec.c, Src/hist.c, Src/init.c,
	Src/mem.c, Src/module.c, Src/params.c, Src/prompt.c,
	Src/Zle/computil.c, Src/Zle/zle_main.c: Add some missing
	unqueue_signals().

	* 39521: Src/exec.c, Src/zsh.h, Test/A01grammar.ztst: Refactor
	start of execcmd().  This allows execpline2() easier access to
	the state at the start of execuation.

2016-10-02  Peter Stephenson  <p.w.stephenson@ntlworld.com>

	* 39540: Src/exec.c, Test/C03traps.ztst: "! command" should
	suppress ERR_EXIT and ERR_RETURN.

2016-09-30  Daniel Shahaf  <d.s@daniel.shahaf.name>

	* 39495: Doc/Zsh/contrib.yo, Functions/Misc/add-zle-hook-widget:
	add-zle-hook-widget: Add end-of-options guard to hook invocation.

	* 39480: Completion/Debian/Command/_bug: _reportbug: Complete
	absolute filenames, too.

2016-09-30  Barton E. Schaefer  <schaefer@zsh.org>

	* unposted: Doc/Zsh/builtins.yo: update or remove references to
	typeset behavior obsoleted by 35586.

	* 39509: Src/builtins.c: in the event the current directory has
	been removed, use chasedots semantics for "cd ..".

2016-09-30  Peter Stephenson  <p.stephenson@samsung.com>

	* 39519: Src/params.c: setting PM_EXPORT was missing in
	USE_SET_UNSET_ENV case.

	* 39517: back off 39502, this isn't a robust fix.

	* 39498: Src/parmas.c,Src/zsh.h: use PRIVILEGED option to
	decide on problematic parameter imports.

2016-09-30  Mikael Magnusson  <mikachu@gmail.com>

	* 39452 + comment from 39432: Src/Zle/zle_main.c: Call the
	pre-redraw hook if there is text in the buffer on init (from
	popping or zle-line-init setting $BUFFER)

2016-09-30  Oliver Kiddle  <opk@zsh.org>

	* 39514: Completion/Unix/Command/_git: handle --git-dir

	* 39513: Completion/Unix/Command/_doas: new doas completion

	* 39464: Completion/Solaris/Command/_fmadm: fix where lack
	of $state check caused unwanted filename completion

2016-09-29  Barton E. Schaefer  <schaefer@zsh.org>

	* 39507: Doc/Zsh/params.yo, Src/exec.c: TMPSUFFIX for =(...)

	* 39470: Src/exec.c, Src/utils.c: failure to open a supposedly
	unique temp file name should result in an error; band-aid for
	signal-related race conditions in temp file name generation

2016-09-29  Peter Stephenson  <p.stephenson@samsung.com>

	* 39502: Src/exec.c, Test/A01grammar.ztst: need to fork for
	assignment in LHS of pipeline.

	* unposted: Src/Zle/compctl.c, Src/Zle/zle_tricky.c: update
	findcmd() call here, too.

	* 39493: Src/builtin.c, Src/exec.c, Src/subst.c,
	Test/A01grammar.ztst: make "command" with multiple options work
	better and ensure "command -p" with "-v" or "-V" checks for a
	builtin and then using the system default command path.

2016-09-28  Peter Stephenson  <p.stephenson@samsung.com>

	* Martijn Dekker: 39463: configure.ac: another way of getting
	the default system path.

	* 39460: Src/params.c, Src/zsh.h: don't import PS4 if running as
	root.  Currently no known exploit with this in zsh as xtrace
	needs an explicit option setting, so this is just precautionary.

2016-09-27  Oliver Kiddle  <opk@zsh.org>

	* Marko Myllynen: 39453: Completion/Unix/Command/_openstack:
	new openstack completions

	* 39369 (tweaked cf 39371): Src/Zle/zle_thingy.c: when calling
	an internal widget, set bindk because some widgets use it to
	determine how they should act
